/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* $Source: chips/p9/procedures/hwp/lib/p9_pm_stop_history.H $            */
/*                                                                        */
/* IBM CONFIDENTIAL                                                       */
/*                                                                        */
/* EKB Project                                                            */
/*                                                                        */
/* COPYRIGHT 2015,2016                                                    */
/* [+] International Business Machines Corp.                              */
/*                                                                        */
/*                                                                        */
/* The source code for this program is not published or otherwise         */
/* divested of its trade secrets, irrespective of what has been           */
/* deposited with the U.S. Copyright Office.                              */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
///
/// @file p9_hcd_common.H
/// @brief common hcode includes
///

// *HWP HWP Owner          : Greg Still     <stillgs@us.ibm.com>
// *HWP HWP BackupeOwner   : David Du       <daviddu@us.ibm.com>
// *HWP FW Owner           : Sangeetha T S  <sangeet2@in.ibm.com>
// *HWP Team               : PM
// *HWP Consumed by        : SBE:HS:CRO

#ifndef __P9_SSH_H__
#define __P9_SSH_H__


namespace p9ssh
{

// Note: these are not autogenerated as multiple registers have the
// same bit layout
static const uint32_t STOP_GATED_START           = 0;
static const uint32_t STOP_GATED_LEN             = 1;

static const uint32_t STOP_TRANSITION_START      = 2;
static const uint32_t STOP_TRANSITION_LEN        = 2;

static const uint32_t STOP_REQUESTED_LEVEL_START = 4;
static const uint32_t STOP_REQUESTED_LEVEL_LEN   = 4;

static const uint32_t STOP_ACTUAL_LEVEL_START    = 8;
static const uint32_t STOP_ACTUAL_LEVEL_LEN      = 4;

static const uint32_t STOP_REQ_WRITE_EN          = 12;
static const uint32_t STOP_ACT_WRITE_EN          = 13;

enum STOP_HISTORY_GATED
{
    SSH_RUNNING = 0,
    SSH_GATED = 1
};

enum STOP_HISTORY_TRANSITION
{
    SSH_COMPLETE = 0,
    SSH_CORE_COMPLETE = 1,
    SSH_ENTERING = 2,
    SSH_EXITING = 3,
    SSH_UNDEFINED = 255
};

} // namespace
#endif  // __P9_SSH_H__
